Unit ASP0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASP0C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var T :Array of Complex;
                var S :Array of Integer; N :Integer; M :Integer;
                P :Integer);

implementation

procedure ASP0C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var T :Array of Complex;
                var S :Array of Integer; N :Integer; M :Integer;
                P :Integer);
var
I,J,K,L :Integer;
E,F,R,G,H,TR :Real;
D,C :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27;
begin
if ( P = 1 ) 
 then goto _1;
goto _19;
_1:
for K:=1 to M do
 begin
  if ( K <> N ) 
   then goto _2;
  T[K-1] := A[(K-1)+(K-1)*N];
  A[(K-1)+(K-1)*N] := Cmplx(0.0,0.0);
  S[K-1] := K;
  goto _19;
_2:
  L := K;
  E := 0.0;
  for J:=K to M do
   begin
    F := 0.0;
    for I:=K to N do
     begin
      D := A[(I-1)+(J-1)*N];
      R := Creal(D);
      G := Aimag(D);
      R := Abs(R);
      G := Abs(G);
      H := EMax1(R,G);
      if ( H = 0.0 ) 
       then goto _3;
      R := R/H;
      G := G/H;
      R := R*R+G*G;
      H := H*Sqrt(R);
_3:
      if ( F < H ) 
       then F := H;
_4:
     end;
    H := 0.0;
    TR := 1.0/F;
    for I:=K to N do
     begin
      D := A[(I-1)+(J-1)*N];
      R := Creal(D)*TR;
      G := Aimag(D)*TR;
_5:
      H := H+R*R+G*G;
     end;
    F := Sqrt(H)*F;
    if ( E >= F ) 
     then goto _6;
    E := F;
    L := J;
_6:
   end;
  if ( L = K ) 
   then goto _8;
  for I:=1 to N do
   begin
    D := A[(I-1)+(L-1)*N];
    A[(I-1)+(L-1)*N] := A[(I-1)+(K-1)*N];
_7:
    A[(I-1)+(K-1)*N] := D;
   end;
_8:
  S[K-1] := L;
  F := 1.0/E;
  for I:=K to N do
   begin
_9:
    T[I-1] := MulC(A[(I-1)+(K-1)*N],Cmplx(F,0.0));
   end;
  R := Creal(T[K-1]);
  G := Aimag(T[K-1]);
  R := Abs(R);
  G := Abs(G);
  F := EMax1(R,G);
  if ( F <> 0.0 ) 
   then goto _10;
  T[K-1] := Cmplx(1.0,0.0);
  D := Cmplx(-E,0.0);
  goto _12;
_10:
  R := R/F;
  G := G/F;
  R := R*R+G*G;
  F := F*Sqrt(R);
  D := DivC(T[K-1],Cmplx(F,0.0));
  T[K-1] := AddC(T[K-1],D);
  F := 1.0/Sqrt(1.0+F);
  for I:=K to N do
   begin
_11:
    T[I-1] := MulC(T[I-1],Cmplx(F,0.0));
   end;
  D := MulC(Cmplx(-E,0.0),D);
_12:
  for I:=K to N do
   begin
_13:
    A[(I-1)+(K-1)*N] := T[I-1];
   end;
  if ( K = M ) 
   then goto _17;
  L := K+1;
  for J:=L to M do
   begin
    C := Cmplx(0.0,0.0);
    for I:=K to N do
     begin
_14:
      C := AddC(C,MulC(A[(I-1)+(J-1)*N],Conjg(T[I-1])));
     end;
    for I:=K to N do
     begin
_15:
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(C,T[I-1]));
     end;
_16:
   end;
_17:
  T[K-1] := D;
_18:
 end;
_19:
for J:=1 to M do
 begin
  if ( J = N ) 
   then goto _23;
  C := Cmplx(0.0,0.0);
  for I:=J to N do
   begin
    D := A[(I-1)+(J-1)*N];
_20:
    C := AddC(C,MulC(B[I-1],Conjg(D)));
   end;
  for I:=J to N do
   begin
_21:
    B[I-1] := SubC(B[I-1],MulC(C,A[(I-1)+(J-1)*N]));
   end;
_22:
 end;
_23:
I := M;
X[I-1] := DivC(B[I-1],T[I-1]);
if ( M = 1 ) 
 then goto _27;
_24:
L := I;
I := I-1;
C := Cmplx(0.0,0.0);
for J:=L to M do
 begin
_25:
  C := AddC(C,MulC(A[(I-1)+(J-1)*N],X[J-1]));
 end;
X[I-1] := DivC((SubC(B[I-1],C)),T[I-1]);
if ( I > 1 ) 
 then goto _24;
J := M;
_26:
J := J-1;
I := S[J-1];
D := X[J-1];
X[J-1] := X[I-1];
X[I-1] := D;
if ( J > 1 ) 
 then goto _26;
_27:
end;

end.
